(ns com.aurellem.title2
  (:use (com.aurellem gb-funs vbm)))

(defn first-difference [base alt summary root]
  (loop [branch-point root
         actions []]
    (let [base-branch (step branch-point base)
          base-val (summary base-branch)
          alt-branch (step branch-point alt)
          alt-val (summary alt-branch)]
      (if (not= base-val alt-val)
        [(conj actions alt) alt-branch]
        (recur base-branch (conj actions base))))))

(defn advance
  ([base alt summary [commands state]]
     (let [[c s] (first-difference base alt summary state)]
       [(concat commands c) s]))
  ([base alt [commands state]]
     (advance base alt AF [commands state]))
  ([alt [commands state]]
     (advance [] alt [commands state])))

(def scroll-text (partial advance [:b] [:a :b]))

(defn title []
  (->> [[] (root)]
       (advance [] [:a])
       (advance [] [:start])
       (advance [] [:a])
       (advance [] [:start])))

(def title-end (second (title)))

(defn oak []
  (->> [[] title-end]
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       scroll-text
       (advance [] [:a])))

;; looks like it might need a monad here if this pattern continues

(def oak-end (second (oak)))
           
(defn name-entry []
  (->> [[] oak-end]
       (advance [] [:r] DE)
       ((fn [[moves state]]
          (play-moves
           state
            [[]
             [:r] [] [:r] [] [:r] [] [:r] []
             [:r] [] [:r] [] [:r] [] [:d] [:a]  
             [:l] [] [:l] [] [:l] [] [:l] []
             [:l] [] [:l] [:a] [] [:r] [:a]
             [:r] [] [:r] [] [:r] [] [:r] []
             [:r] [] [:d] [] [:d] [] [:d] [:a]
             ])))))
          

